// Direct3D9MFCView.cpp : CDirect3D9MFCView ʵ
//

#include "stdafx.h"
#include "Direct3D9MFC.h"

#include "Direct3D9MFCDoc.h"
#include "Direct3D9MFCView.h"
#include ".\direct3d9mfcview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CDirect3D9MFCView

IMPLEMENT_DYNCREATE(CDirect3D9MFCView, CView)

BEGIN_MESSAGE_MAP(CDirect3D9MFCView, CView)
	// ׼ӡ
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	ON_WM_SIZE()
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

// CDirect3D9MFCView /

CDirect3D9MFCView::CDirect3D9MFCView()
: _device(0), _teapot(0) 
{
	// TODO: ڴ˴ӹ
::ZeroMemory(&_d3dpp, sizeof(_d3dpp));
}

CDirect3D9MFCView::~CDirect3D9MFCView()
{
	if( _teapot ) 
	_teapot->Release(); 
	if( _device ) 
	_device->Release(); 
}

BOOL CDirect3D9MFCView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ڴ˴ͨ޸ CREATESTRUCT cs ޸Ĵ
	// ʽ

	return CView::PreCreateWindow(cs);
}

// CDirect3D9MFCView 

void CDirect3D9MFCView::OnDraw(CDC* /*pDC*/)
{
	CDirect3D9MFCDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: ڴ˴Ϊӻƴ
}


// CDirect3D9MFCView ӡ

BOOL CDirect3D9MFCView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// Ĭ׼
	return DoPreparePrinting(pInfo);
}

void CDirect3D9MFCView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ӡǰӶĳʼ
}

void CDirect3D9MFCView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ӡ
}


// CDirect3D9MFCView 

#ifdef _DEBUG
void CDirect3D9MFCView::AssertValid() const
{
	CView::AssertValid();
}

void CDirect3D9MFCView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDirect3D9MFCDoc* CDirect3D9MFCView::GetDocument() const // ǵ԰汾
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDirect3D9MFCDoc)));
	return (CDirect3D9MFCDoc*)m_pDocument;
}
#endif //_DEBUG


// CDirect3D9MFCView Ϣ

//ʼinitD3Dʵ
//The initD3D method is responsible for initializing Direct3D, that is, obtaining a 
//pointer to an IDirect3DDevice9 interface based on the arguments passed in.
HRESULT CDirect3D9MFCView::initD3D(HWND hwnd, 
                           int  width, 
                           int  height, 
                           bool windowed, 
                           D3DDEVTYPE deviceType) 
{ 
	HRESULT hr = 0; 
 
	  // Step 1: Create the IDirect3D9 object. 
 
	  IDirect3D9* d3d9 = 0; 
	  d3d9 = Direct3DCreate9(D3D_SDK_VERSION); 
 
      if( !d3d9 ) 
		{ 
		::MessageBox(0, "Direct3DCreate9() - FAILED", 0, 0); 
		return E_FAIL; 
		} 
 
  // Step 2: Check for hardware vp. 
 
	D3DCAPS9 caps; 
	d3d9->GetDeviceCaps(D3DADAPTER_DEFAULT, deviceType, &caps); 
 
	int vp = 0; 
	if( caps.DevCaps & D3DDEVCAPS_HWTRANSFORMANDLIGHT ) 
	vp = D3DCREATE_HARDWARE_VERTEXPROCESSING; 
    else 
    vp = D3DCREATE_SOFTWARE_VERTEXPROCESSING; 
 
  // Step 3: Fill out the D3DPRESENT_PARAMETERS structure. 
  
    _d3dpp.BackBufferWidth            = width; 
    _d3dpp.BackBufferHeight           = height; 
    _d3dpp.BackBufferFormat           = D3DFMT_A8R8G8B8; 
    _d3dpp.BackBufferCount            = 1; 
    _d3dpp.MultiSampleType            = D3DMULTISAMPLE_NONE; 
    _d3dpp.MultiSampleQuality         = 0; 
    _d3dpp.SwapEffect                 = D3DSWAPEFFECT_DISCARD;  
    _d3dpp.hDeviceWindow              = hwnd; 
    _d3dpp.Windowed                   = windowed; 
    _d3dpp.EnableAutoDepthStencil     = true;  
    _d3dpp.AutoDepthStencilFormat     = D3DFMT_D24S8; 
    _d3dpp.Flags                      = 0; 
    _d3dpp.FullScreen_RefreshRateInHz = D3DPRESENT_RATE_DEFAULT; 
    _d3dpp.PresentationInterval       = D3DPRESENT_INTERVAL_IMMEDIATE; 
 
  // Step 4: Create the device. 
    hr = d3d9->CreateDevice( 
    D3DADAPTER_DEFAULT, // primary adapter 
    deviceType,         // device type 
    hwnd,               // window associated with device 
    vp,                 // vertex processing 
        &_d3dpp,            // present parameters 
        &_device);          // return created device 
 
  if( FAILED(hr) ) 
	{ 
	// try again using a safer configuration. 
		_d3dpp.AutoDepthStencilFormat = D3DFMT_D16; 
   
		hr = d3d9->CreateDevice( 
		D3DADAPTER_DEFAULT, 
		deviceType, 
		hwnd, 
		D3DCREATE_SOFTWARE_VERTEXPROCESSING, 
		&_d3dpp, 
		&_device); 
 
   if( FAILED(hr) ) 
	{ 
		d3d9->Release(); // done with d3d9 object 
		 ::MessageBox(0, "CreateDevice() - FAILED", 0, 0); 
		 return hr; 
	 } 
 } 
 
	d3d9->Release(); // done with d3d9 object 
  
	 return S_OK; 
} 

HRESULT CDirect3D9MFCView::setup(int width, int height) 
{ 
  if( _device ) 
	{

	// Set view matrix. 
 
	D3DXMATRIX V; 
    D3DXVECTOR3 pos    (0.0f, 0.0f, -6.0f); 
    D3DXVECTOR3 target (0.0f, 0.0f,  0.0f); 
    D3DXVECTOR3 up     (0.0f, 1.0f,  0.0f); 
 
    D3DXMatrixLookAtLH(&V, &pos, &target, &up); 
 
    _device->SetTransform(D3DTS_VIEW, &V); 
  // Create the teapot. 
   
	 if( !_teapot) 
     D3DXCreateTeapot(_device, &_teapot, 0); 
 
   // Use wireframe mode and turn off lighting. 
 
	_device->SetRenderState(D3DRS_FILLMODE, D3DFILL_WIREFRAME); 
	_device->SetRenderState(D3DRS_LIGHTING, false); 
 
   // Size the viewport based on window dimensions. 
    D3DVIEWPORT9 vp = {0, 0, width, height, 0.0f, 1.0f}; 
	_device->SetViewport( &vp ); 
 
   // Set the projection matrix based on the 
   // window dimensions. 
    D3DXMATRIX P; 
    D3DXMatrixPerspectiveFovLH( 
								&P, 
								D3DX_PI * 0.25f,//45-degree field of view 
								(float)width / (float)height, 
								1.0f, 
								1000.0f); 
 
   _device->SetTransform(D3DTS_PROJECTION, &P); 
 } 
 
  return S_OK; 
} 

HRESULT CDirect3D9MFCView::cleanup() 
{ 
  // Nothing to Destroy. 
     return S_OK; 
} 

HRESULT CDirect3D9MFCView::update(float timeDelta) 
{ 
  if( _device ) 
 { //  
   // Spin the teapot around the y-axis. 
   // 
 
   static float angle = 0.0f; 
   D3DXMATRIX yRotationMatrix; 
   D3DXMatrixRotationY(&yRotationMatrix, angle); 
 
   _device->SetTransform(D3DTS_WORLD, &yRotationMatrix); 
 
   angle += timeDelta; 
 
   if(angle >= D3DX_PI * 2.0f) 
   angle = 0.0f; 
 } 
 
  return S_OK; 
} 
HRESULT CDirect3D9MFCView::render() 
{ 
  if( _device ) 
 { 
   // 
   // Draw the scene. 
   // 
 
  _device->Clear(0, 0,  
   D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, 
   0x00000000, 1.0f, 0); 
 
  _device->BeginScene(); 
 
  // Draw the teapot. 
  _teapot->DrawSubset(0); 
 
  _device->EndScene(); 
 
  _device->Present(0, 0, 0, 0);

 } 
 
  return S_OK; 
} 
void CDirect3D9MFCView::OnInitialUpdate()
{
	CView::OnInitialUpdate();

	// TODO: ڴרô/û
	CRect rect;
	GetClientRect(&rect);
	// Initialize Direct3D (e.g. acquire a IDirect3DDevice9 poniter).
	HRESULT hr = initD3D(
						GetSafeHwnd(),
						rect.right,
						rect.bottom,
						true,
						D3DDEVTYPE_HAL);
	if(FAILED(hr))
	{
		MessageBox("initD3D() - Failed", "Error");
		::PostQuitMessage(0);
	}

	// Setup the application.
	hr = setup(rect.right, rect.bottom);
	if(FAILED(hr))
	{
		MessageBox("setup() - Failed", "Error");
		::PostQuitMessage(0);
	}
}

//BOOL CDirect3D9MFCView::OnWndMsg(UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pResult)
//{
//	// TODO: ڴרô/û
//
//	return CView::OnWndMsg(message, wParam, lParam, pResult);
//}

void CDirect3D9MFCView::OnSize(UINT nType, int cx, int cy)
{
	CView::OnSize(nType, cx, cy);

	// TODO: ڴ˴Ϣ

	if( _device )
		{
		HRESULT hr = 0;
		// On a resize we must change the dimensions of the
		// back buffers to match the new window size.
		_d3dpp.BackBufferWidth = cx;
		_d3dpp.BackBufferHeight = cy;
		// We are about to call Reset, free any resources
		// that need to be freed prior to a Reset.
		hr = cleanup();
		if(FAILED(hr))
		{
		MessageBox("destroy() - Failed", "Error");
		::PostQuitMessage(0);
		}
// Reset the flipping chain with the new window dimensions.
// Note that all device states are reset to the default
// after this call.
		hr = _device->Reset(&_d3dpp);
		if(FAILED(hr))
		{
		MessageBox("Reset() - Failed", "Error");
		::PostQuitMessage(0);
		}
		// Reinitialize resource and device states since we
		// Reset everything.
		hr = setup(cx, cy);
		if(FAILED(hr))
		{
			MessageBox("setup() - Failed", "Error");
			::PostQuitMessage(0);
		}
	}

}

BOOL CDirect3D9MFCView::OnEraseBkgnd(CDC* pDC)
{
	// TODO: ڴϢ/Ĭֵ

	return false;
}
